# CfnServiceLevelObjective

Creates or updates a service level objective (SLO), which can help you ensure that your critical business operations are meeting customer expectations.

Use SLOs to set and track specific target levels for the reliability and availability of your applications and services. SLOs use service level indicators (SLIs) to calculate whether the application is performing at the level that you want.

Create an SLO to set a target for a service operation, or service dependency's availability or latency. CloudWatch measures this target frequently you can find whether it has been breached.

The target performance quality that is defined for an SLO is the *attainment goal* . An attainment goal is the percentage of time or requests that the SLI is expected to meet the threshold over each time interval. For example, an attainment goal of 99.9% means that within your interval, you are targeting 99.9% of the periods to be in healthy state.

When you create an SLO, you specify whether it is a *period-based SLO* or a *request-based SLO* . Each type of SLO has a different way of evaluating your application's performance against its attainment goal.

- A *period-based SLO* uses defined *periods* of time within a specified total time interval. For each period of time, Application Signals determines whether the application met its goal. The attainment rate is calculated as the `number of good periods/number of total periods` .

For example, for a period-based SLO, meeting an attainment goal of 99.9% means that within your interval, your application must meet its performance goal during at least 99.9% of the time periods.
- A *request-based SLO* doesn't use pre-defined periods of time. Instead, the SLO measures `number of good requests/number of total requests` during the interval. At any time, you can find the ratio of good requests to total requests for the interval up to the time stamp that you specify, and measure that ratio against the goal set in your SLO.

After you have created an SLO, you can retrieve error budget reports for it. An *error budget* is the amount of time or amount of requests that your application can be non-compliant with the SLO's goal, and still have your application meet the goal.

- For a period-based SLO, the error budget starts at a number defined by the highest number of periods that can fail to meet the threshold, while still meeting the overall goal. The *remaining error budget* decreases with every failed period that is recorded. The error budget within one interval can never increase.

For example, an SLO with a threshold that 99.95% of requests must be completed under 2000ms every month translates to an error budget of 21.9 minutes of downtime per month.
- For a request-based SLO, the remaining error budget is dynamic and can increase or decrease, depending on the ratio of good requests to total requests.

When you call this operation, Application Signals creates the *AWSServiceRoleForCloudWatchApplicationSignals* service-linked role, if it doesn't already exist in your account. This service- linked role has the following permissions:

- `xray:GetServiceGraph`
- `logs:StartQuery`
- `logs:GetQueryResults`
- `cloudwatch:GetMetricData`
- `cloudwatch:ListMetrics`
- `tag:GetResources`
- `autoscaling:DescribeAutoScalingGroups`

You can easily set SLO targets for your applications, and their dependencies, that are discovered by Application Signals, using critical metrics such as latency and availability. You can also set SLOs against any CloudWatch metric or math expression that produces a time series.

> You can't create an SLO for a service operation that was discovered by Application Signals until after that operation has reported standard metrics to Application Signals.

You cannot change from a period-based SLO to a request-based SLO, or change from a request-based SLO to a period-based SLO.

For more information about SLOs, see [Service level objectives (SLOs)](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch-ServiceLevelObjectives.html) .

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnServiceLevelObjective
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IServiceLevelObjectiveRef, IConstruct, IDependable

- CloudFormation: [`AWS::ApplicationSignals::ServiceLevelObjective`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-applicationsignals-servicelevelobjective.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_applicationsignals as applicationsignals } from 'aws-cdk-lib';
const cfnServiceLevelObjective = new applicationsignals.CfnServiceLevelObjective(this, 'MyCfnServiceLevelObjective', {
  name: 'name',

  // the properties below are optional
  burnRateConfigurations: [{
    lookBackWindowMinutes: 123,
  }],
  description: 'description',
  exclusionWindows: [{
    window: {
      duration: 123,
      durationUnit: 'durationUnit',
    },

    // the properties below are optional
    reason: 'reason',
    recurrenceRule: {
      expression: 'expression',
    },
    startTime: 'startTime',
  }],
  goal: {
    attainmentGoal: 123,
    interval: {
      calendarInterval: {
        duration: 123,
        durationUnit: 'durationUnit',
        startTime: 123,
      },
      rollingInterval: {
        duration: 123,
        durationUnit: 'durationUnit',
      },
    },
    warningThreshold: 123,
  },
  requestBasedSli: {
    requestBasedSliMetric: {
      compositeSliConfig: {
        selectionConfig: {
          type: 'type',

          // the properties below are optional
          pattern: 'pattern',
        },

        // the properties below are optional
        compositeSliComponents: [{
          operationName: 'operationName',
        }],
      },
      dependencyConfig: {
        dependencyKeyAttributes: {
          dependencyKeyAttributesKey: 'dependencyKeyAttributes',
        },
        dependencyOperationName: 'dependencyOperationName',
      },
      keyAttributes: {
        keyAttributesKey: 'keyAttributes',
      },
      metricName: 'metricName',
      metricSource: {
        metricSourceKeyAttributes: {
          metricSourceKeyAttributesKey: 'metricSourceKeyAttributes',
        },

        // the properties below are optional
        metricSourceAttributes: {
          metricSourceAttributesKey: 'metricSourceAttributes',
        },
      },
      metricType: 'metricType',
      monitoredRequestCountMetric: {
        badCountMetric: [{
          id: 'id',

          // the properties below are optional
          accountId: 'accountId',
          expression: 'expression',
          metricStat: {
            metric: {
              dimensions: [{
                name: 'name',
                value: 'value',
              }],
              metricName: 'metricName',
              namespace: 'namespace',
            },
            period: 123,
            stat: 'stat',

            // the properties below are optional
            unit: 'unit',
          },
          returnData: false,
        }],
        goodCountMetric: [{
          id: 'id',

          // the properties below are optional
          accountId: 'accountId',
          expression: 'expression',
          metricStat: {
            metric: {
              dimensions: [{
                name: 'name',
                value: 'value',
              }],
              metricName: 'metricName',
              namespace: 'namespace',
            },
            period: 123,
            stat: 'stat',

            // the properties below are optional
            unit: 'unit',
          },
          returnData: false,
        }],
      },
      operationName: 'operationName',
      totalRequestCountMetric: [{
        id: 'id',

        // the properties below are optional
        accountId: 'accountId',
        expression: 'expression',
        metricStat: {
          metric: {
            dimensions: [{
              name: 'name',
              value: 'value',
            }],
            metricName: 'metricName',
            namespace: 'namespace',
          },
          period: 123,
          stat: 'stat',

          // the properties below are optional
          unit: 'unit',
        },
        returnData: false,
      }],
    },

    // the properties below are optional
    comparisonOperator: 'comparisonOperator',
    metricThreshold: 123,
  },
  sli: {
    comparisonOperator: 'comparisonOperator',
    metricThreshold: 123,
    sliMetric: {
      compositeSliConfig: {
        selectionConfig: {
          type: 'type',

          // the properties below are optional
          pattern: 'pattern',
        },

        // the properties below are optional
        compositeSliComponents: [{
          operationName: 'operationName',
        }],
      },
      dependencyConfig: {
        dependencyKeyAttributes: {
          dependencyKeyAttributesKey: 'dependencyKeyAttributes',
        },
        dependencyOperationName: 'dependencyOperationName',
      },
      keyAttributes: {
        keyAttributesKey: 'keyAttributes',
      },
      metricDataQueries: [{
        id: 'id',

        // the properties below are optional
        accountId: 'accountId',
        expression: 'expression',
        metricStat: {
          metric: {
            dimensions: [{
              name: 'name',
              value: 'value',
            }],
            metricName: 'metricName',
            namespace: 'namespace',
          },
          period: 123,
          stat: 'stat',

          // the properties below are optional
          unit: 'unit',
        },
        returnData: false,
      }],
      metricName: 'metricName',
      metricSource: {
        metricSourceKeyAttributes: {
          metricSourceKeyAttributesKey: 'metricSourceKeyAttributes',
        },

        // the properties below are optional
        metricSourceAttributes: {
          metricSourceAttributesKey: 'metricSourceAttributes',
        },
      },
      metricType: 'metricType',
      operationName: 'operationName',
      periodSeconds: 123,
      statistic: 'statistic',
    },
  },
  tags: [{
    key: 'key',
    value: 'value',
  }],
});
```

## Initializer

```ts
new CfnServiceLevelObjective(scope: Construct, id: string, props: CfnServiceLevelObjectiveProps)
```

## Construct Props

- `burnRateConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.BurnRateConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.BurnRateConfigurationProperty.html)[] — Each object in this array defines the length of the look-back window used to calculate one burn rate metric for this SLO.

  The burn rate measures how fast the service is consuming the error budget, relative to the attainment goal of the SLO.

- `description`: string — An optional description for this SLO.

  **Default:** "No description"

- `exclusionWindows`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.ExclusionWindowProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.ExclusionWindowProperty.html)[] — The time window to be excluded from the SLO performance metrics.

- `goal`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.GoalProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.GoalProperty.html) — This structure contains the attributes that determine the goal of an SLO.

  This includes the time period for evaluation and the attainment threshold.

- `name`: string (required) — A name for this SLO.

- `requestBasedSli`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.RequestBasedSliProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.RequestBasedSliProperty.html) — A structure containing information about the performance metric that this SLO monitors, if this is a request-based SLO.

- `sli`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.SliProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.SliProperty.html) — A structure containing information about the performance metric that this SLO monitors, if this is a period-based SLO.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs to associate with the SLO.

  You can associate as many as 50 tags with an SLO. To be able to associate tags with the SLO when you create the SLO, you must have the cloudwatch:TagResource permission.

  Tags can help you organize and categorize your resources. You can also use them to scope user permissions by granting a user permission to access or change only resources with certain tag values.

## Properties

- `attrArn`: string — The ARN of this SLO.

- `attrCreatedTime`: number — The date and time that this SLO was created.

- `attrEvaluationType`: string — Displays whether this is a period-based SLO or a request-based SLO.

- `attrLastUpdatedTime`: number — The time that this SLO was most recently updated.

- `burnRateConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.BurnRateConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.BurnRateConfigurationProperty.html)[] — Each object in this array defines the length of the look-back window used to calculate one burn rate metric for this SLO.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `description`: string — An optional description for this SLO.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `exclusionWindows`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.ExclusionWindowProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.ExclusionWindowProperty.html)[] — The time window to be excluded from the SLO performance metrics.

- `goal`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.GoalProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.GoalProperty.html) — This structure contains the attributes that determine the goal of an SLO.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `name`: string — A name for this SLO.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `requestBasedSli`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.RequestBasedSliProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.RequestBasedSliProperty.html) — A structure containing information about the performance metric that this SLO monitors, if this is a request-based SLO.

- `serviceLevelObjectiveRef`: [ServiceLevelObjectiveReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_applicationsignals.ServiceLevelObjectiveReference.html) — A reference to a ServiceLevelObjective resource.

- `sli`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnServiceLevelObjective.SliProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_applicationsignals.CfnServiceLevelObjective.SliProperty.html) — A structure containing information about the performance metric that this SLO monitors, if this is a period-based SLO.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs to associate with the SLO.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForServiceLevelObjective(resource: IServiceLevelObjectiveRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnServiceLevelObjective(x: any): boolean` (static) — Checks whether the given object is a CfnServiceLevelObjective.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
